<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: bit_hacks/bit_hacks.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_64eb892c6bd55b82613c6a491afc7b54.html">bit_hacks</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">bit_hacks.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdint.h&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for bit_hacks.h:</div>
<div class="dyncontent">
<div class="center"><img src="bit__hacks_8h__incl.png" border="0" usemap="#bit__hacks_2bit__hacks_8h" alt=""/></div>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="bit__hacks_8h__dep__incl.png" border="0" usemap="#bit__hacks_2bit__hacks_8hdep" alt=""/></div>
<map name="bit__hacks_2bit__hacks_8hdep" id="bit__hacks_2bit__hacks_8hdep">
<area shape="rect" id="node2" href="bit__hacks_8c.html" title="bit_hacks/bit_hacks.c" alt="" coords="5,80,155,107"/>
<area shape="rect" id="node3" href="bit__hacks_2test_8c.html" title="bit_hacks/test.c" alt="" coords="179,80,293,107"/>
<area shape="rect" id="node4" href="bit__hacks_2verify_8c.html" title="bit_hacks/verify.c" alt="" coords="317,80,443,107"/>
<area shape="rect" id="node5" href="crc32_2test_8c.html" title="crc32/test.c" alt="" coords="467,80,557,107"/>
</map>
</div>
</div>
<p><a href="bit__hacks_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad56990640efca96116337c655ff20984"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a></td></tr>
<tr class="separator:ad56990640efca96116337c655ff20984"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d5cc979bba2c75551f4a97a33b902ef"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#a5d5cc979bba2c75551f4a97a33b902ef">U16_SET_BIT</a>(X)&#160;&#160;&#160;((uint16_t)1U &lt;&lt; (X))</td></tr>
<tr class="separator:a5d5cc979bba2c75551f4a97a33b902ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b3535ebdbe2e88b533c69e527586e1b"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#a8b3535ebdbe2e88b533c69e527586e1b">U32_SET_BIT</a>(X)&#160;&#160;&#160;((uint32_t)1 &lt;&lt; (X))</td></tr>
<tr class="separator:a8b3535ebdbe2e88b533c69e527586e1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad2d98dd947a531e52070a4483b20674c"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#ad2d98dd947a531e52070a4483b20674c">U64_SET_BIT</a>(X)&#160;&#160;&#160;((uint64_t)1 &lt;&lt; (X))</td></tr>
<tr class="separator:ad2d98dd947a531e52070a4483b20674c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a044b7cf7e5a7d689dc847d052f97c7c3"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#a044b7cf7e5a7d689dc847d052f97c7c3">IS_POWER_OF_TWO</a>(X)&#160;&#160;&#160;((X)) &amp;&amp; (((X) &amp; ((X)-1)) == 0)</td></tr>
<tr class="separator:a044b7cf7e5a7d689dc847d052f97c7c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a9e5edb66844fb07c735dab608d4e775f"><td class="memItemLeft" align="right" valign="top"><a class="el" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#a9e5edb66844fb07c735dab608d4e775f">reverse_uint8_bits</a> (uint8_t value)</td></tr>
<tr class="separator:a9e5edb66844fb07c735dab608d4e775f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcfa1fe17a4acc518ca5065fb32d60dc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="bit__hacks_8h.html#afcfa1fe17a4acc518ca5065fb32d60dc">reverse_uint32_bits</a> (uint32_t value)</td></tr>
<tr class="separator:afcfa1fe17a4acc518ca5065fb32d60dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Helper functions for bit twiddling. </p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad56990640efca96116337c655ff20984"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad56990640efca96116337c655ff20984">&#9670;&nbsp;</a></span>BIT_HACKS_SPEC</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define BIT_HACKS_SPEC</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>CONFIGURATION: Define for header only library, undefine for standalone module. </p>

</div>
</div>
<a id="a044b7cf7e5a7d689dc847d052f97c7c3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a044b7cf7e5a7d689dc847d052f97c7c3">&#9670;&nbsp;</a></span>IS_POWER_OF_TWO</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IS_POWER_OF_TWO</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">X</td><td>)</td>
          <td>&#160;&#160;&#160;((X)) &amp;&amp; (((X) &amp; ((X)-1)) == 0)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Given an non-negative integer, return true if its value is a power of two. </p>

</div>
</div>
<a id="a5d5cc979bba2c75551f4a97a33b902ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d5cc979bba2c75551f4a97a33b902ef">&#9670;&nbsp;</a></span>U16_SET_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define U16_SET_BIT</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">X</td><td>)</td>
          <td>&#160;&#160;&#160;((uint16_t)1U &lt;&lt; (X))</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create an expression of type uint16_t with a single bit set at bit position X (with 0 = least significant bit). </p>

</div>
</div>
<a id="a8b3535ebdbe2e88b533c69e527586e1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8b3535ebdbe2e88b533c69e527586e1b">&#9670;&nbsp;</a></span>U32_SET_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define U32_SET_BIT</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">X</td><td>)</td>
          <td>&#160;&#160;&#160;((uint32_t)1 &lt;&lt; (X))</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create an expression of type uint32_t with a single bit set at bit position X (with 0 = least significant bit). </p>

</div>
</div>
<a id="ad2d98dd947a531e52070a4483b20674c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad2d98dd947a531e52070a4483b20674c">&#9670;&nbsp;</a></span>U64_SET_BIT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define U64_SET_BIT</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">X</td><td>)</td>
          <td>&#160;&#160;&#160;((uint64_t)1 &lt;&lt; (X))</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create an expression of type uint64_t with a single bit set at bit position X (with 0 = least significant bit). </p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="afcfa1fe17a4acc518ca5065fb32d60dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afcfa1fe17a4acc518ca5065fb32d60dc">&#9670;&nbsp;</a></span>reverse_uint32_bits()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint32_t reverse_uint32_bits </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Reverse order of bits of an uint32_t value. </p>

</div>
</div>
<a id="a9e5edb66844fb07c735dab608d4e775f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9e5edb66844fb07c735dab608d4e775f">&#9670;&nbsp;</a></span>reverse_uint8_bits()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="bit__hacks_8h.html#ad56990640efca96116337c655ff20984">BIT_HACKS_SPEC</a> uint8_t reverse_uint8_bits </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Reverse order of bits of an uint8_t value. </p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
